
package cz.upol.pja.lecture04.controllers;

import cz.upol.pja.lecture04.model.Address;
import cz.upol.pja.lecture04.model.Customer;
import java.util.List;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.Persistence;

@RequestScoped
@Named("customersCtl")
public class CustomersCtl {
    
    private final EntityManager entityManager = Persistence.createEntityManagerFactory("lecture04PU").createEntityManager();
    
    private boolean insertAction = false;
    
    private String name;
    private String itin;
    private String street;
    private String city;
    private String zip;

    public CustomersCtl() {
    }
    
    public List<Customer> getItems() {
        return (List<Customer>) entityManager.createQuery("select item from Customer item").getResultList();
    }
    
    public String saveForm() {
        entityManager.getTransaction().begin();
        Customer customer = new Customer(name, itin, new Address(street, city, zip));
        if (insertAction) {
            entityManager.persist(customer);
        } else {
            entityManager.merge(customer);
        }
        entityManager.getTransaction().commit();
        return "customers";
    }
    
    public String editForm(Customer customer) {
        this.name = customer.getName();
        this.itin = customer.getItin();
        this.street = customer.getAddress().getStreet();
        this.city = customer.getAddress().getCity();
        this.zip = customer.getAddress().getZip();
        return "customer-edit";
    }
    
    public String delete(Customer customer) {
        entityManager.getTransaction().begin();
        entityManager.remove(customer);
        entityManager.getTransaction().commit();
        return "";
    }
    
    public String insertForm() {
        this.insertAction = true;
        return "customer-edit";
    }
    // <editor-fold defaultstate="collapsed" desc="getters & setters">

    public boolean isInsertAction() {
        return insertAction;
    }

    public void setInsertAction(boolean insertAction) {
        this.insertAction = insertAction;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getItin() {
        return itin;
    }

    public void setItin(String itin) {
        this.itin = itin;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getZip() {
        return zip;
    }

    public void setZip(String zip) {
        this.zip = zip;
    }
    // </editor-fold>
}
