
package cz.upol.pja.lecture04.controllers;

import cz.upol.pja.lecture04.model.StockItem;
import java.math.BigDecimal;
import java.util.List;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

@RequestScoped
@Named("stockItemsCtl")
public class StockItemsCtl {
    
    private final EntityManagerFactory emfactory = Persistence.createEntityManagerFactory("lecture04PU");    
    private final EntityManager entityManager = emfactory.createEntityManager();
    
    private boolean insertAction = false;
    private String itemName = "";
    private String unit = "";
    private BigDecimal unitPrice = new BigDecimal(0);

    public StockItemsCtl() {
    }
     
   public List<StockItem> getItems() {
        return (List<StockItem>) entityManager.createQuery("select item from StockItem item").getResultList();
    }
    
    public String saveForm() {
	// zahaji transakci
        entityManager.getTransaction().begin();
        StockItem item = new StockItem(itemName, unit, unitPrice);
        if (insertAction) {
	    // novy objekt je vlozen do tabulky
            entityManager.persist(item);
        } else {
	    //zmeny jsou aplikovany
            entityManager.merge(item);
        }
        entityManager.getTransaction().commit();
        return "stock-items";
    }
    
    public String editForm(StockItem item) {
        this.itemName = item.getItemName();
        this.unit = item.getUnit();
        this.unitPrice = item.getUnitPrice();
        return "stock-item-edit";
    }
    
    public String delete(StockItem item) {
        entityManager.getTransaction().begin();
	// odstraneni objektu z databaze
        entityManager.remove(item);
        entityManager.getTransaction().commit();
        return "";
    }
    
    public String insertForm() {
        this.insertAction = true;
        return "stock-item-edit";
    }
    
    // <editor-fold defaultstate="collapsed" desc="getters & setters">
    public String getItemName() {
        return itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public BigDecimal getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(BigDecimal unitPrice) {
        this.unitPrice = unitPrice;
    }
    
    public boolean isInsertAction() {
        return insertAction;
    }

    public void setInsertAction(boolean insertAction) {
        this.insertAction = insertAction;
    }
    
    // </editor-fold>
}
