
package cz.upol.pja.lecture04.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Objects;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name = "stock_items")
public class StockItem implements Serializable {
    
    @Id
    @Column(name = "item_name", length = 50)
    private String itemName;
    
    @Column(length = 10)
    private String unit;
    
    @Column(precision = 12, scale = 3)
    private BigDecimal unitPrice;

    public StockItem() {
    }

    public StockItem(String itemName, String unit, BigDecimal unitPrice) {
        this.itemName = itemName;
        this.unit = unit;
        this.unitPrice = unitPrice;
    }

    // <editor-fold defaultstate="collapsed" desc="getters & setters">
    public String getItemName() {
        return itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public BigDecimal getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(BigDecimal unitPrice) {
        this.unitPrice = unitPrice;
    }
    
    
    @Override
    public int hashCode() {
        int hash = 3;
        hash = 97 * hash + Objects.hashCode(this.itemName);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final StockItem other = (StockItem) obj;
        if (!Objects.equals(this.itemName, other.itemName)) {
            return false;
        }
        return true;
    }
    
    // </editor-fold>

}
